#include "defs.h"


/*
 * This is part of JEliza 2.3.
 * Copyright 2006 by Tobias Schulz
 * WWW: http://jeliza.ch.to/
 *
 * JEliza is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 *
 * JEliza is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU GPL
 * along with JEliza (file gpl.txt) ; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

using namespace std;


#include <windows.h>
#include <tchar.h>

#include "cAgent.h"


bool speechOk = false;
auto_ptr<cAgent> msagent;
bool jeliza::speech_activated = false;
bool had_activated = false;

void speech_init() {
    msagent.reset(new cAgent());
    speechOk = true;
    msagent->Command ("MoveTo  Center 0");
    msagent->Command ("Show    Fast");
    msagent->Command ("Language german");
//    msagent->Command ("Volume master on");
//    msagent->Command ("Volume wave on");
//    msagent->Command ("Volume master 100");
//    msagent->Command ("Volume wave 100");

    msagent->Command ("Speak   Guten Tag!");
}



void speak(string str) {
    if (not jeliza::speech_activated) {
        return;
    }

    if (not had_activated) {
        had_activated = true;
        speech_init();
    }

    str = jeliza::string(str).replace_nocase(jeliza::string("&nbsp;"), jeliza::string(" "))
            .replace_nocase(jeliza::string("&nbsp"), jeliza::string(" "))
            .replace_nocase(jeliza::string("nbsp"), jeliza::string(" "))
            .replace_nocase(jeliza::string("&"), jeliza::string(" "))
            .replace(jeliza::string(";"), jeliza::string(" "))
            .replace(jeliza::string("  "), jeliza::string(" "))
            .ref();

    // Make the character speak
    string scmd = "Speak " + str;
    char* cmd = const_cast<char*>(scmd.c_str());
    msagent->Command(cmd);
}

