/* copyright © by Stefan Voitel, 2003 - all rights reserved                   */
/* eMail : stefan.voitel@winways.de                                           */

#include "cAgent.h"
#include "cPhrase.hpp"
#include "AgtSvr_i.c"

cAgent::cAgent (char *FileName) :
        Terminate(false),iAgentEx(NULL),SinkID(-1),Event(meOff) {

DblClickTime = GetDoubleClickTime();
ZeroMemory (CharacterFileName,sizeof(CharacterFileName));

if (FileName != NULL && *FileName) {
   strncpy (CharacterFileName,FileName,sizeof(CharacterFileName) -1);

   if (! strstr(CharacterFileName,".acs"))
      strcat (CharacterFileName,".acs");
   }

if ((Sink = new cAgentSink (this)) != NULL) { // calls FromSinkThread_Init

   if (iAgentEx == NULL || iCharacterEx == NULL) {
      throw "cAgent::cAgent() fails, condition : iAgent || iCharacter";
      }
   }
else throw ("cAgent::cAgent() fails, condition : cAgentSink");
}

cAgent::~cAgent () {
Terminate = true;

if (!IsBadCodePtr((FARPROC) Sink))
   delete Sink; // calls FromSinkThread_Free

CoUninitialize();
}

// ****************************************************************************
// publics
// ****************************************************************************

bool     cAgent::Script             (char *File,char *Key) {
bool success = false;
char SCFile[MAX_PATH] , *pFile;

CHAR* temp1 = toWChar(pFile);

if (SearchPath (NULL,toWChar(File),NULL,MAX_PATH,toWChar(SCFile),&temp1)) {
   char *script = (char*) GlobalAlloc (GPTR,0x8000 *sizeof(char));

   if (script != NULL) {
      if (GetPrivateProfileSection (toWChar(Key),toWChar(script),0x8000,toWChar(SCFile))) {
         success = true;
         char     *next = script;
         size_t   len;

         while ((len = strlen (next)) > 0) {
            if (strstr (next,"Goto") == next) {
               char *p = next;

               while (*p && *p != '\t' && *p != ' ') p++;
               while (*p && (*p == '\t' || *p == ' ')) p++;

               if (*p)
                  Script (File,p);
               }
            else Command (next);
            next += (len+1);
            }
         }
      else {
         char msg[1024];
         wsprintf (toWChar(msg), toWChar("File  : %s\r\n""Key  : %s\r\n"),SCFile,Key);
         MessageBox (0,toWChar(msg),toWChar("key not found"),MB_ICONASTERISK);
         }

      GlobalFree ((HGLOBAL) script);
      }
   }
return success;
}              // ---------------------

bool     cAgent::Command            (char* cmd) {
bool success = false;

if (strstr (cmd,"Phrase") == cmd) {
   char *p = cmd;

   while (*p && *p != '\t' && *p != ' ') p++;
   while (*p && (*p == '\t' || *p == ' ')) p++;

   if (*p) {
      cPhrase *cp;
      if ((cp = new cPhrase (p)) != NULL) {
         char    *phrase;

         if ((phrase = cp->Get()) != NULL) {
            do {
               char *speak = new char[strlen (phrase) +12];

               wsprintf (toWChar(speak),toWChar("Speak %s"),toWChar(phrase));
               Command (speak);
               success = true;

               delete[] speak;
               } while ((phrase = cp->Get()) != NULL);
            }
         delete cp;
         }
      }
   }
else if (strstr (cmd,"Stop") == cmd) {
   char *p = cmd;

   while (*p && *p != '\t' && *p != ' ') p++;
   while (*p && (*p == '\t' || *p == ' ')) p++;
   Stop (p);
   }
else success = Sink->AddCommand (cmd);

Sleep (1);  // yield for cAgentSink::ExecThread()
return success;
}              // ---------------------

void     cAgent::GetIdle            (void) {
MSG   msg;
while (Sink->HasQueuedCommands()) {
   while (PeekMessage (&msg,NULL,0,0,PM_REMOVE)) {
      DispatchMessage (&msg);
      }
   Sleep (100);
   }
}              // ---------------------

void     cAgent::GetQuit            (void) {
MSG   msg;
while (!Terminate) {
   while (PeekMessage (&msg,NULL,0,0,PM_REMOVE)) {
      DispatchMessage (&msg);
      }
   Sleep (100);
   }
}

// ****************************************************************************
// procedures callded from inside cAgentSink::ExecuteThread
// ****************************************************************************

HRESULT  cAgent::FromSinkThread_Init    (void) {
HRESULT  Result;

if (SUCCEEDED ((Result = CoInitialize (NULL)))) {
   if (SUCCEEDED ((Result = CoCreateInstance (CLSID_AgentServer,NULL,
   						      CLSCTX_SERVER,IID_IAgentEx,(LPVOID*) &iAgentEx)))) {
      LONG     lReqID;
      VARIANT	vPath;

      int      len   = (int) strlen (CharacterFileName);
      wchar_t *file = new wchar_t[len +1];

      if (MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,CharacterFileName,-1,
                                                  file,sizeof(wchar_t) *len)) {
         VariantInit (&vPath);
         vPath.vt      = VT_BSTR;
         vPath.bstrVal = SysAllocString (file);

         if (vPath.bstrVal != NULL)
	         Result = iAgentEx->Load (vPath,&CharacterID,&lReqID);
         }
      delete[] file;

      if (FAILED (Result)) {           // Load default Character
         VariantInit (&vPath);
	      vPath.vt = VT_EMPTY;
	      Result = iAgentEx->Load (vPath,&CharacterID,&lReqID);
         }

      if (SUCCEEDED (Result)) {
         Result = iAgentEx->GetCharacterEx (CharacterID,&iCharacterEx);
         }
      VariantClear (&vPath);
      }
   }
return Result;
}              // ---------------------


HRESULT  cAgent::FromSinkThread_Free    (void) {
HRESULT  Result = E_FAIL;

if (! IsBadCodePtr ((FARPROC) iAgentEx)) {
   if (! IsBadCodePtr ((FARPROC) iCharacterEx)) {
      iCharacterEx->Release();
      Result = iAgentEx->Unload (CharacterID);
	   }
   iAgentEx->Release();
   }
return Result;
}              // ---------------------

bool     cAgent::FromSinkThread_Command (char *Line) {
bool SetSinkTrigger = true;


while (*Line && (*Line == '\t' || *Line == ' ')) Line++;

if (*Line && *Line != ';') {

   RequestID = -1;
   char *args = Line;

   while (*args && *args != '\t' && *args != ' ') args++;
   while (*args && (*args == '\t' || *args == ' ')) args++;

   #define IsCmd(c) (bool) (strstr (Line,c) == Line)
   if (IsCmd ("Speak"))          SetSinkTrigger = Speak (args);
   else if (IsCmd ("Think"))     SetSinkTrigger = Think (args);
   else if (IsCmd ("Play"))      SetSinkTrigger = Play  (args);
   else if (IsCmd ("MoveTo"))    SetSinkTrigger = MoveTo(args);
   else if (IsCmd ("Move"))      SetSinkTrigger = Move  (args);
   else if (IsCmd ("Show"))      SetSinkTrigger = Show  (args);
   else if (IsCmd ("Hide"))      SetSinkTrigger = Hide  (args);

   else if (IsCmd ("Size"))      Size     (args);
   else if (IsCmd ("Resize"))    Resize   (args);
   else if (IsCmd ("Language"))  Language (args);
   else if (IsCmd ("Menu"))      Menu     (args);
   else if (IsCmd ("Name"))      Name     (args);
   else if (IsCmd ("Volume"))    Volume   (args);
   else if (IsCmd ("Sounds"))    Sounds   (args);
   else if (IsCmd ("Execute"))   Execute  (args);
   else if (IsCmd ("ShellRun"))  ShellRun (args);
   else if (IsCmd ("Quit"))      Terminate = true;
   else MessageBox (NULL,toWChar(Line),toWChar("unexpect command"),MB_ICONINFORMATION);
   #undef IsCmd
   }
return SetSinkTrigger;
}               // ---------------------

void     cAgent::FromSinkThread_CheckStop (void) {
if (iCharacterEx != NULL) {
    if (StopPlaying && RequestID != -1)
       iCharacterEx->Stop(RequestID);
    }
StopPlaying = false;
}

/******************************************************************************/
// Click / DblClick Thread
/******************************************************************************/

DWORD WINAPI cAgent::ClickEvent (void *p) {
cAgent *O = (cAgent*) p;

teMouseClient  client = O->Keys & keyTray ? mcTrayIcon : mcCharacter;
teVirtualKeys  vkey   = vkNone;


if (O->Keys & keyShift)
   vkey = (teVirtualKeys) (vkey | vkShift);

if (O->Keys & keyCtrl)
   vkey = (teVirtualKeys) (vkey | vkCtrl);

if (O->Keys & keyAlt)
   vkey = (teVirtualKeys) (vkey | vkAlt);

Sleep (O->DblClickTime);

if (O->Event == meClick) {
   if (O->Keys & keyLeft)
      O->LeftClick (vkey,client);
   if (O->Keys & keyRight)
      O->RightClick (vkey,client);
   }
else if (O->Event == me2Click) {
   if (O->Keys & keyLeft)
      O->LeftDblClick (vkey,client);
   if (O->Keys & keyRight)
      O->RightDblClick (vkey,client);
   }

O->Event = meOff;
O->Keys  = keyNone;
return 0;
}
// EOF

